local source_code
N, C, myself, source_code, colors = ...
raise = coroutine.yield

local error = error
local load = load
local rawget = rawget
local co_create = coroutine.create
local co_resume = coroutine.resume
local co_status = coroutine.status

local function assert(v, ...)
  if v then return v, ... end
  error(... or 'unknown error!', 0)
end

local program = assert(load(source_code, '=program.lua', 't'))
local co = co_create(program)

local ok, hand = assert(co_resume(co))
assert(co_status(co) == 'suspended', 'raise() was never called')
assert(hand == true or hand == false, 'argument to raise() must be true or false')

local function phase2(hands)
  assert(co_resume(co, hands))
  assert(co_status(co) == 'dead', 'raise() was called twice')
  local answer = rawget(_ENV, 'answer')
  assert(answer ~= nil, 'answer is nil')
  assert(type(answer) == 'number', 'answer is not a number')
  return answer
end

return hand, phase2
